//	2014/06/09


#ifndef LIST_HPP
#define LIST_HPP 1


class LINK{
	LINK* next;
	LINK* back;
	void* data;
protected:
	LINK(){
		next=0;
		back=0;
		data=0;
	}
	void set(void* d){
		data=d;
	}
	friend class LIST;
	friend int cmp(const void* d,const void* s){
		if((char*)d>(char*)s)
			return 1;
		if((char*)d<(char*)s)
			return -1;
		return 0;
		
	}
};

typedef void* LPVOID;

class LIST{
	LINK* top;	//	Xg̐擪
	LINK* end;	//	Xg̍Ō
	LINK* pos;	//	Xg̃Jg|WV
	int max;	//	Xg̗vf
protected:
	LIST(){
		pos=top=end=0;
		max=0;
	}
	LINK* append(void* d){	//	Xg̍ŌɃf[^ǉ
		LINK* p=new LINK;
		++max;
		p->data=d;
		if(top==0){
			pos=top=end=p;
		}else{
			end->next=p;
			p->back=end;
			end=p;
		}
		return p;
	}
	void* next(void){	//	Jg|WWf[^𓾂AJg|WVPi߂B
		LINK* t=pos;
		if(pos==0){
			return 0;
		}else{
			pos=pos->next;
			return t->data;
		}
	}
	void* first(void){	//	Jg|WV擪Ɉړ擪f[^𓾂AJg|WVPi߂B
		pos=top;
		return next();
	}
	void all_del(void){	//	XgS폜
		while(top){
			LINK* t=top->next;
			delete top;
			top=t;
		}
		top=end=pos=0;
		max=0;
	}
	void repeat_del(int(*cmp )(const void* d,const void* s)){	//	\[gꂽXgdvf폜
		LINK* lp=top;
		if(lp){
			LINK* bp=0;
			while(lp){
				if(bp){
					if( (*cmp)((void**)&lp->data,(void**)&bp->data) ){	//	O̗vfƈقȂꍇ
						bp=lp;
					}else{	//	O̗vfƓꍇ
						LINK* t=lp->next;
						del(lp);
						--max;
						lp=t;
						continue;
					}
				}else
					bp=lp;
				lp=lp->next;
			}
		}
	}	
	void qsort(int(*cmp )(const void* d,const void* s)){
		if(max){
			int n=0;
			LPVOID* vec=new LPVOID[max];	//	Xg̗vfzɃRs[
			if(vec==0)
				return;
			void* p;
			p=first();
			while(p){
				vec[n++]=p;
				p=next();
			}
			::qsort((void*)vec,max,sizeof(LPVOID),cmp);
			LINK* lp=top;						//	zXgɃRs[
			n=0;
			while(lp){
				lp->set(vec[n++]);
				lp=lp->next;
			}
			delete vec;
		}
	}
	void del(LINK*	p){	// Xgp폜
		if(p){
			--max;
			if(p==top){	//	p͐擪ł
				LINK* t=top;
				top=top->next;
				if(top){
					top->back=0;
					if(pos==p){
						pos=p->next;
					}
				}else
					end=pos=0;
				delete p;
				return;
			}
			if(p==end){
				LINK* t=end;
				end=end->back;
				end->next=0;
				delete p;
				return;
			}
			LINK* t=p;
			p->back->next=p->next;
			p->next->back=p->back;
			if(pos==p){
				pos=p->next;
			}
			delete t;
		}

	}
public:
	int get_max(void){
		return max;
	}
};

#endif
